// based on example from http://en.cppreference.com/w/cpp/numeric/random/rand
#include <cstdlib>
#include <iostream>
#include <ctime>
#include <random>
#include <vector>
#include <algorithm>
#include "BinaryOctet.h"

// for println();
std::string as_string(BinaryOctet a) {
    std::string result = "(";
    for (char c : a.bitsAsDigits) {
        result += c;
    }
    result += ")";
    return result;
}


std::string as_string(BinaryOctet *a) {
    std::string result = "(";
    for (char c : a->bitsAsDigits) {
        result += c;
    }
    result += ")";
    return result;
}

// for std::cout
std::ostream &operator<<(std::ostream &os, BinaryOctet toBePrinted) {
os << as_string(toBePrinted);
return os;
}


std::ostream &operator<<(std::ostream &os, BinaryOctet *toBePrinted) {
    os << as_string(toBePrinted);
    return os;
}

int main() {
    std::srand(static_cast<unsigned int>(std::time(nullptr)));

    std::default_random_engine generator;
    std::uniform_int_distribution<int> distribution(0, 23);

    std::vector<BinaryOctet> binVector;
    for (int i = 0; i <= 41; i++) {
        int rnd = distribution(generator);
        auto bin = rnd;
        std::cout << i << ": " << bin << std::endl;
        auto iterator = std::find(binVector.begin(), binVector.end(), bin);
        if(iterator == binVector.end()) {
            binVector.emplace_back(bin);
        }
    }
    std::sort(binVector.begin(), binVector.end());
    for(BinaryOctet binaryOctet : binVector) {
        std::cout << binaryOctet << std::endl;
    }
}
