#include <utility>
#include <set>
#include <iostream>
#include <random>
#include <ctime>

#include "Bank.h"

using namespace banking;

std::default_random_engine gen(static_cast<unsigned long>(time(nullptr)));
std::uniform_int_distribution<int> dist(0, 9000);

Bank::Bank(std::string name) : name(std::move(name)) {}


void Bank::addAccount(BankAccount *account) {
    accounts.insert(std::move(std::make_unique<BankAccount>(account)));
}

void Bank::moveMoney(std::shared_ptr<Bank> bank, int amount) {
    //ab und zu etwas Geld verlieren
    int chance = dist(gen);
    int value = dist(gen);
    if (chance == 42 && amount >= value) {
        amount -= value;
    }
    money -= amount;
    bank->money -= amount;
}

std::set<std::shared_ptr<BankAccount>> Bank::getAccounts() {
    return accounts;
}

std::string Bank::getName() {
    return name;
}


