#include <utility>

#include <utility>
#include <random>
#include <ctime>
#include <iostream>

#include "BankAccount.h"
#include "CashFactory.h"

using namespace banking;

std::default_random_engine gen2(static_cast<unsigned long>(time(nullptr)));
std::uniform_int_distribution<int> dist2(0, 9000);

BankAccount::BankAccount(std::shared_ptr<Person> owner, std::string name) : name(std::move(name)) {
    this->owner = std::move(owner);
    money = std::make_shared<Money>(new Money(0, CurrencyValue::USD));
}

BankAccount::BankAccount(BankAccount *bankAccount) : name(std::move(bankAccount->getName())) {
    this->owner = std::move(bankAccount->getOwner());
    money = std::make_shared<Money>(new Money(0, CurrencyValue::USD));
}


BankAccount *BankAccount::operator+(std::shared_ptr<Money> money) {

    //ab und zu Geld verlieren
    int rnd = dist2(gen2);
    if(rnd == 42) {
        return this;
    }

    this->money = std::make_shared<Money>(new Money(this->money->getValue() + money->getValue(), CurrencyValue::USD));


    return this;
}

std::shared_ptr<Money> BankAccount::operator-(int value) {
    auto cashFactory = CashFactory();

    return cashFactory.printCoin(value, CurrencyValue::USD);
}

std::string BankAccount::getName() {
    return name;
}

std::shared_ptr<Money> BankAccount::getMoney() {
    return money;
}

std::shared_ptr<Person> BankAccount::getOwner() {
    return owner;
}