#ifndef C_C_BANKACCOUNTS_H
#define C_C_BANKACCOUNTS_H

#include <unordered_map>
#include <memory>

#include "Money.h"
#include "Person.h"

/**
 * @namespace banking
 * \ingroup banking
 */
namespace banking {

    /**
     * @author Johannes Theiner<kontakt@joethei.xyz>
     * @version 1.0
     */
    class BankAccount {
    private:
        std::string name;
        std::shared_ptr<Person> owner;
        std::shared_ptr<Money> money;
    public:
        explicit BankAccount(std::shared_ptr<Person> owner, std::string name);

        explicit BankAccount(BankAccount *bankAccount);

        BankAccount *operator+(std::shared_ptr<Money> money);

        std::shared_ptr<Money> operator-(int value);

        std::string getName();

        std::shared_ptr<Person> getOwner();

        std::shared_ptr<Money> getMoney();
    };
}


#endif