#ifndef C_C_CASHFACTORY_H
#define C_C_CASHFACTORY_H

#include <string>
#include <memory>
#include <vector>
#include "Bill.h"
#include "Coin.h"

/**
 * @namespace banking
 * \ingroup banking
 */
namespace banking {

    /**
     * @author Johannes Theiner<kontakt@joethei.xyz
     * @version 1.0
     */
    class CashFactory {
    private:
        std::string randomString(size_t length);
    public:
        std::shared_ptr<Bill> printBill(int value, Currency currency);
        std::shared_ptr<Coin> printCoin(int value, Currency currency);
    };
}


#endif