#ifndef C_C_MONEY_H
#define C_C_MONEY_H

#include "Currency.h"

/**
 * @namespace banking
 * \ingroup banking
 */
namespace banking {

    /**
     * @author Johannes Theiner<kontakt@joethei.xyz>
     * @version 1.0
     */
    class Money {
    private:
        int value;
        Currency currency;
    public:
        explicit Money(int value = 0, Currency currency = CurrencyValue::USD);

        explicit Money(Money *money);

        Money &operator=(Money money);

        Money &operator=(Money *money);

        Money operator+(Money &a);

        Money operator-(Money &a);

        const Money operator++(int);

        const Money operator--(int);

        bool operator<(Money &a);

        virtual int getValue();

        Currency getCurrency();
    };
}


#endif
